/*
 * Snippet Model
 * -------------------------------------------------------------
 * Put some description here!
 */
const uuid = require('uuid/v4')
const Snippet = {
    schema: {
        name: String,
        user_id: String,
        archived: {
            type: Boolean,
            default: false
        },
        data: String,
        shared_user_ids: [String],
        edit_user_ids: [String],
        uuid: {
            type: String,
            default: uuid
        },
        public_share: String,
        mode: String,
        project_id: String,
    },
}

module.exports = exports = Snippet